ICU 78.1: icu::TimeZoneFormat Class Reference

ICU 78.1 78.1

Public Member Functions | Static Public Member Functions | Protected Member Functions
icu::TimeZoneFormat Class Reference

`TimeZoneFormat` supports time zone display name formatting and parsing. More...

`#include <tzfmt.h>`

Inheritance diagram for icu::TimeZoneFormat:

## Public Member Functions
U_I18N_API | TimeZoneFormat (const TimeZoneFormat &other)
| Copy constructor. More...
virtual U_I18N_API | ~TimeZoneFormat ()
| Destructor. More...
U_I18N_API TimeZoneFormat & | operator= (const TimeZoneFormat &other)
| Assignment operator. More...
virtual U_I18N_API bool | operator== (const Format &other) const override
| Return true if the given Format objects are semantically equal. More...
virtual U_I18N_API TimeZoneFormat * | clone () const override
| Clone this object polymorphically. More...
U_I18N_API const TimeZoneNames * | getTimeZoneNames () const
| Returns the time zone display name data used by this instance. More...
U_I18N_API void | adoptTimeZoneNames (TimeZoneNames *tznames)
| Sets the time zone display name data to this format instance. More...
U_I18N_API void | setTimeZoneNames (const TimeZoneNames &tznames)
| Sets the time zone display name data to this format instance. More...
U_I18N_API UnicodeString & | getGMTPattern (UnicodeString &pattern) const
| Returns the localized GMT format pattern. More...
U_I18N_API void | setGMTPattern (const UnicodeString &pattern, UErrorCode &status)
| Sets the localized GMT format pattern. More...
U_I18N_API UnicodeString & | getGMTOffsetPattern (UTimeZoneFormatGMTOffsetPatternType type, UnicodeString &pattern) const
| Returns the offset pattern used for localized GMT format. More...
U_I18N_API void | setGMTOffsetPattern (UTimeZoneFormatGMTOffsetPatternType type, const UnicodeString &pattern, UErrorCode &status)
| Sets the offset pattern for the given offset type. More...
U_I18N_API UnicodeString & | getGMTOffsetDigits (UnicodeString &digits) const
| Returns the decimal digit characters used for localized GMT format. More...
U_I18N_API void | setGMTOffsetDigits (const UnicodeString &digits, UErrorCode &status)
| Sets the decimal digit characters used for localized GMT format. More...
U_I18N_API UnicodeString & | getGMTZeroFormat (UnicodeString &gmtZeroFormat) const
| Returns the localized GMT format string for GMT(UTC) itself (GMT offset is 0). More...
U_I18N_API void | setGMTZeroFormat (const UnicodeString &gmtZeroFormat, UErrorCode &status)
| Sets the localized GMT format string for GMT(UTC) itself (GMT offset is 0). More...
U_I18N_API uint32_t | getDefaultParseOptions () const
| Returns the bitwise flags of UTimeZoneFormatParseOption representing the default parse options used by this object. More...
U_I18N_API void | setDefaultParseOptions (uint32_t flags)
| Sets the default parse options. More...
U_I18N_API UnicodeString & | formatOffsetISO8601Basic (int32_t offset, UBool useUtcIndicator, UBool isShort, UBool ignoreSeconds, UnicodeString &result, UErrorCode &status) const
| Returns the ISO 8601 basic time zone string for the given offset. More...
U_I18N_API UnicodeString & | formatOffsetISO8601Extended (int32_t offset, UBool useUtcIndicator, UBool isShort, UBool ignoreSeconds, UnicodeString &result, UErrorCode &status) const
| Returns the ISO 8601 extended time zone string for the given offset. More...
U_I18N_API UnicodeString & | formatOffsetLocalizedGMT (int32_t offset, UnicodeString &result, UErrorCode &status) const
| Returns the localized GMT(UTC) offset format for the given offset. More...
U_I18N_API UnicodeString & | formatOffsetShortLocalizedGMT (int32_t offset, UnicodeString &result, UErrorCode &status) const
| Returns the short localized GMT(UTC) offset format for the given offset. More...
virtual U_I18N_API UnicodeString & | format (UTimeZoneFormatStyle style, const TimeZone &tz, UDate date, UnicodeString &name, UTimeZoneFormatTimeType *timeType=nullptr) const
| Returns the display name of the time zone at the given date for the style. More...
U_I18N_API int32_t | parseOffsetISO8601 (const UnicodeString &text, ParsePosition &pos) const
| Returns offset from GMT(UTC) in milliseconds for the given ISO 8601 style time zone string. More...
U_I18N_API int32_t | parseOffsetLocalizedGMT (const UnicodeString &text, ParsePosition &pos) const
| Returns offset from GMT(UTC) in milliseconds for the given localized GMT offset format string. More...
U_I18N_API int32_t | parseOffsetShortLocalizedGMT (const UnicodeString &text, ParsePosition &pos) const
| Returns offset from GMT(UTC) in milliseconds for the given short localized GMT offset format string. More...
virtual U_I18N_API TimeZone * | parse (UTimeZoneFormatStyle style, const UnicodeString &text, ParsePosition &pos, int32_t parseOptions, UTimeZoneFormatTimeType *timeType=nullptr) const
| Returns a `TimeZone` by parsing the time zone string according to the given parse position, the specified format style and parse options. More...
U_I18N_API TimeZone * | parse (UTimeZoneFormatStyle style, const UnicodeString &text, ParsePosition &pos, UTimeZoneFormatTimeType *timeType=nullptr) const
| Returns a `TimeZone` by parsing the time zone string according to the given parse position, the specified format style and the default parse options. More...
virtual U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const override
| Format an object to produce a time zone display string using localized GMT offset format. More...
virtual U_I18N_API void | parseObject (const UnicodeString &source, Formattable &result, ParsePosition &parse_pos) const override
| Parse a string to produce an object. More...
virtual U_I18N_API UClassID | getDynamicClassID () const override
| ICU "poor man's RTTI", returns a UClassID for the actual class. More...
U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, UErrorCode &status) const
| Formats an object to produce a string. More...
virtual U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPosition &pos, UErrorCode &status) const=0
| Format an object to produce a string. More...
virtual U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const
| Format an object to produce a string. More...
Public Member Functions inherited from icu::Format
virtual U_I18N_API | ~Format ()
| Destructor. More...
U_I18N_API bool | operator!= (const Format &other) const
| Return true if the given Format objects are not semantically equal. More...
U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, UErrorCode &status) const
| Formats an object to produce a string. More...
virtual U_I18N_API UnicodeString & | format (const Formattable &obj, UnicodeString &appendTo, FieldPositionIterator *posIter, UErrorCode &status) const
| Format an object to produce a string. More...
U_I18N_API void | parseObject (const UnicodeString &source, Formattable &result, UErrorCode &status) const
| Parses a string to produce an object. More...
U_I18N_API Locale | getLocale (ULocDataLocaleType type, UErrorCode &status) const
| Get the locale for this format object. More...
U_I18N_API const char * | getLocaleID (ULocDataLocaleType type, UErrorCode &status) const
| Get the locale for this format object. More...
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor. More...

## Static Public Member Functions
static U_I18N_API TimeZoneFormat * | createInstance (const Locale &locale, UErrorCode &status)
| Creates an instance of `TimeZoneFormat` for the given locale. More...
static U_I18N_API UClassID | getStaticClassID ()
| ICU "poor man's RTTI", returns a UClassID for this class. More...

## Protected Member Functions
U_I18N_API | TimeZoneFormat (const Locale &locale, UErrorCode &status)
| Constructs a TimeZoneFormat object for the specified locale. More...
Protected Member Functions inherited from icu::Format
U_I18N_API void | setLocaleIDs (const char *valid, const char *actual)
U_I18N_API | Format ()
| Default constructor for subclass use only. More...
U_I18N_API | Format (const Format &)
U_I18N_API Format & | operator= (const Format &)

## Additional Inherited Members
Static Protected Member Functions inherited from icu::Format
static U_I18N_API void | syntaxError (const UnicodeString &pattern, int32_t pos, UParseError &parseError)
| Simple function for initializing a UParseError from a UnicodeString. More...

## Detailed Description

`TimeZoneFormat` supports time zone display name formatting and parsing.

An instance of TimeZoneFormat works as a subformatter of SimpleDateFormat, but you can also directly get a new instance of `TimeZoneFormat` and formatting/parsing time zone display names.

ICU implements the time zone display names defined by UTS#35 Unicode Locale Data Markup Language (LDML). TimeZoneNames represents the time zone display name data model and this class implements the algorithm for actual formatting and parsing.

See also
  SimpleDateFormat
  TimeZoneNames

Stable:
  ICU 50

Definition at line 274 of file tzfmt.h.

## Constructor & Destructor Documentation

## ◆ TimeZoneFormat() [1/2]

U_I18N_API icu::TimeZoneFormat::TimeZoneFormat | ( | const TimeZoneFormat & | other | ) |

Copy constructor.

Stable:
  ICU 50

## ◆ ~TimeZoneFormat()

virtual U_I18N_API icu::TimeZoneFormat::~TimeZoneFormat | ( |  | ) |
| virtual

Destructor.

Stable:
  ICU 50

## ◆ TimeZoneFormat() [2/2]

U_I18N_API icu::TimeZoneFormat::TimeZoneFormat | ( | const Locale & | locale,
|  | UErrorCode & | status
| ) |  |
| protected

Constructs a TimeZoneFormat object for the specified locale.

Parameters

  locale | the locale
  status | receives the status.

Stable:
  ICU 50

## Member Function Documentation

## ◆ adoptTimeZoneNames()

U_I18N_API void icu::TimeZoneFormat::adoptTimeZoneNames | ( | TimeZoneNames * | tznames | ) |

Sets the time zone display name data to this format instance.

The caller should not delete the TimeZoenNames object after it is adopted by this call.

Parameters

  tznames | TimeZoneNames object to be adopted.

Stable:
  ICU 50

## ◆ clone()

virtual U_I18N_API TimeZoneFormat* icu::TimeZoneFormat::clone | ( |  | ) | const
| overridevirtual

Clone this object polymorphically.

The caller is responsible for deleting the result when done.

Returns
  A copy of the object

Stable:
  ICU 50

Implements icu::Format.

## ◆ createInstance()

static U_I18N_API TimeZoneFormat* icu::TimeZoneFormat::createInstance | ( | const Locale & | locale,
|  | UErrorCode & | status
| ) |  |
| static

Creates an instance of `TimeZoneFormat` for the given locale.

Parameters

  locale | The locale.
  status | Receives the status.

Returns
  An instance of `TimeZoneFormat` for the given locale, owned by the caller.

Stable:
  ICU 50

## ◆ format() [1/5]

virtual U_I18N_API UnicodeString& icu::TimeZoneFormat::format | ( | const Formattable & | obj,
|  | UnicodeString & | appendTo,
|  | FieldPosition & | pos,
|  | UErrorCode & | status
| ) |  | const
| overridevirtual

Format an object to produce a time zone display string using localized GMT offset format.

This method handles Formattable objects with a `TimeZone`. If a the Formattable object type is not a `TimeZone`, then it returns a failing UErrorCode.

Parameters

  obj | The object to format. Must be a `TimeZone`.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  pos | On input: an alignment field, if desired. On output: the offsets of the alignment field.
  status | Output param filled with success/failure status.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 50

Implements icu::Format.

## ◆ format() [2/5]

virtual U_I18N_API UnicodeString& icu::Format::format

Format an object to produce a string.

This is a pure virtual method which subclasses must implement. This method allows polymorphic formatting of Formattable objects. If a subclass of Format receives a Formattable object type it doesn't handle (e.g., if a numeric Formattable is passed to a DateFormat object) then it returns a failing UErrorCode.

Parameters

  obj | The object to format.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  pos | On input: an alignment field, if desired. On output: the offsets of the alignment field.
  status | Output param filled with success/failure status.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.0

## ◆ format() [3/5]

virtual U_I18N_API UnicodeString& icu::Format::format

Format an object to produce a string.

Subclasses should override this method. This method allows polymorphic formatting of Formattable objects. If a subclass of Format receives a Formattable object type it doesn't handle (e.g., if a numeric Formattable is passed to a DateFormat object) then it returns a failing UErrorCode.

Parameters

  obj | The object to format.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  posIter | On return, can be used to iterate over positions of fields generated by this format call.
  status | Output param filled with success/failure status.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 4.4

## ◆ format() [4/5]

U_I18N_API UnicodeString& icu::Format::format

Formats an object to produce a string.

Parameters

  obj | The object to format.
  appendTo | Output parameter to receive result. Result is appended to existing contents.
  status | Output parameter filled in with success or failure status.

Returns
  Reference to 'appendTo' parameter.

Stable:
  ICU 2.0

## ◆ format() [5/5]

virtual U_I18N_API UnicodeString& icu::TimeZoneFormat::format | ( | UTimeZoneFormatStyle | style,
|  | const TimeZone & | tz,
|  | UDate | date,
|  | UnicodeString & | name,
|  | UTimeZoneFormatTimeType * | timeType = `nullptr`
| ) |  | const
| virtual

Returns the display name of the time zone at the given date for the style.

Parameters

  style | The style (e.g. `UTZFMT_STYLE_GENERIC_LONG`, `UTZFMT_STYLE_LOCALIZED_GMT`...)
  tz | The time zone.
  date | The date.
  name | Receives the display name.
  timeType | the output argument for receiving the time type (standard/daylight/unknown) used for the display name, or nullptr if the information is not necessary.

Returns
  A reference to the result

See also
  UTimeZoneFormatStyle
  UTimeZoneFormatTimeType

Stable:
  ICU 50

## ◆ formatOffsetISO8601Basic()

U_I18N_API UnicodeString& icu::TimeZoneFormat::formatOffsetISO8601Basic | ( | int32_t | offset,
|  | UBool | useUtcIndicator,
|  | UBool | isShort,
|  | UBool | ignoreSeconds,
|  | UnicodeString & | result,
|  | UErrorCode & | status
| ) |  | const

Returns the ISO 8601 basic time zone string for the given offset.

For example, "-08", "-0830" and "Z"

Parameters

  offset | the offset from GMT(UTC) in milliseconds.
  useUtcIndicator | true if ISO 8601 UTC indicator "Z" is used when the offset is 0.
  isShort | true if shortest form is used.
  ignoreSeconds | true if non-zero offset seconds is appended.
  result | Receives the ISO format string.
  status | Receives the status

Returns
  the ISO 8601 basic format.

See also
  formatOffsetISO8601Extended
  parseOffsetISO8601

Stable:
  ICU 51

## ◆ formatOffsetISO8601Extended()

U_I18N_API UnicodeString& icu::TimeZoneFormat::formatOffsetISO8601Extended | ( | int32_t | offset,
|  | UBool | useUtcIndicator,
|  | UBool | isShort,
|  | UBool | ignoreSeconds,
|  | UnicodeString & | result,
|  | UErrorCode & | status
| ) |  | const

Returns the ISO 8601 extended time zone string for the given offset.

For example, "-08:00", "-08:30" and "Z"

Parameters

  offset | the offset from GMT(UTC) in milliseconds.
  useUtcIndicator | true if ISO 8601 UTC indicator "Z" is used when the offset is 0.
  isShort | true if shortest form is used.
  ignoreSeconds | true if non-zero offset seconds is appended.
  result | Receives the ISO format string.
  status | Receives the status

Returns
  the ISO 8601 basic format.

See also
  formatOffsetISO8601Extended
  parseOffsetISO8601

Stable:
  ICU 51

## ◆ formatOffsetLocalizedGMT()

U_I18N_API UnicodeString& icu::TimeZoneFormat::formatOffsetLocalizedGMT | ( | int32_t | offset,
|  | UnicodeString & | result,
|  | UErrorCode & | status
| ) |  | const

Returns the localized GMT(UTC) offset format for the given offset.

The localized GMT offset is defined by;

- GMT format pattern (e.g. "GMT {0}" - see getGMTPattern)
- Offset time pattern (e.g. "+HH:mm" - see getGMTOffsetPattern)
- Offset digits (e.g. "0123456789" - see getGMTOffsetDigits)
- GMT zero format (e.g. "GMT" - see getGMTZeroFormat)

This format always uses 2 digit hours and minutes. When the given offset has non-zero seconds, 2 digit seconds field will be appended. For example, GMT+05:00 and GMT+05:28:06.

Parameters

  offset | the offset from GMT(UTC) in milliseconds.
  status | Receives the status
  result | Receives the localized GMT format string.

Returns
  A reference to the result.

See also
  parseOffsetLocalizedGMT

Stable:
  ICU 50

## ◆ formatOffsetShortLocalizedGMT()

U_I18N_API UnicodeString& icu::TimeZoneFormat::formatOffsetShortLocalizedGMT | ( | int32_t | offset,
|  | UnicodeString & | result,
|  | UErrorCode & | status
| ) |  | const

Returns the short localized GMT(UTC) offset format for the given offset.

The short localized GMT offset is defined by;

- GMT format pattern (e.g. "GMT {0}" - see getGMTPattern)
- Offset time pattern (e.g. "+HH:mm" - see getGMTOffsetPattern)
- Offset digits (e.g. "0123456789" - see getGMTOffsetDigits)
- GMT zero format (e.g. "GMT" - see getGMTZeroFormat)

This format uses the shortest representation of offset. The hours field does not have leading zero and lower fields with zero will be truncated. For example, GMT+5 and GMT+530.

Parameters

  offset | the offset from GMT(UTC) in milliseconds.
  status | Receives the status
  result | Receives the short localized GMT format string.

Returns
  A reference to the result.

See also
  parseOffsetShortLocalizedGMT

Stable:
  ICU 51

## ◆ getDefaultParseOptions()

U_I18N_API uint32_t icu::TimeZoneFormat::getDefaultParseOptions | ( |  | ) | const

Returns the bitwise flags of UTimeZoneFormatParseOption representing the default parse options used by this object.

Returns
  the default parse options.

See also
  ParseOption

Stable:
  ICU 50

## ◆ getDynamicClassID()

virtual U_I18N_API UClassID icu::TimeZoneFormat::getDynamicClassID | ( |  | ) | const
| overridevirtual

ICU "poor man's RTTI", returns a UClassID for the actual class.

Stable:
  ICU 50

Reimplemented from icu::UObject.

## ◆ getGMTOffsetDigits()

U_I18N_API UnicodeString& icu::TimeZoneFormat::getGMTOffsetDigits | ( | UnicodeString & | digits | ) | const

Returns the decimal digit characters used for localized GMT format.

The return string contains exactly 10 code points (may include Unicode supplementary character) representing digit 0 to digit 9 in the ascending order.

Parameters

  digits | Receives the decimal digits used for localized GMT format.

See also
  setGMTOffsetDigits

Stable:
  ICU 50

## ◆ getGMTOffsetPattern()

U_I18N_API UnicodeString& icu::TimeZoneFormat::getGMTOffsetPattern | ( | UTimeZoneFormatGMTOffsetPatternType | type,
|  | UnicodeString & | pattern
| ) |  | const

Returns the offset pattern used for localized GMT format.

Parameters

  type | The offset pattern type enum.
  pattern | Receives the offset pattern.

Returns
  A reference to the result pattern.

See also
  setGMTOffsetPattern

Stable:
  ICU 50

## ◆ getGMTPattern()

U_I18N_API UnicodeString& icu::TimeZoneFormat::getGMTPattern | ( | UnicodeString & | pattern | ) | const

Returns the localized GMT format pattern.

Parameters

  pattern | Receives the localized GMT format pattern.

Returns
  A reference to the result pattern.

See also
  setGMTPattern

Stable:
  ICU 50

## ◆ getGMTZeroFormat()

U_I18N_API UnicodeString& icu::TimeZoneFormat::getGMTZeroFormat | ( | UnicodeString & | gmtZeroFormat | ) | const

Returns the localized GMT format string for GMT(UTC) itself (GMT offset is 0).

Parameters

  gmtZeroFormat | Receives the localized GMT string string for GMT(UTC) itself.

Returns
  A reference to the result GMT string.

See also
  setGMTZeroFormat

Stable:
  ICU 50

## ◆ getStaticClassID()

static U_I18N_API UClassID icu::TimeZoneFormat::getStaticClassID | ( |  | ) |
| static

ICU "poor man's RTTI", returns a UClassID for this class.

Stable:
  ICU 50

## ◆ getTimeZoneNames()

U_I18N_API const TimeZoneNames* icu::TimeZoneFormat::getTimeZoneNames | ( |  | ) | const

Returns the time zone display name data used by this instance.

Returns
  The time zone display name data.

Stable:
  ICU 50

## ◆ operator=()

U_I18N_API TimeZoneFormat& icu::TimeZoneFormat::operator= | ( | const TimeZoneFormat & | other | ) |

Assignment operator.

Stable:
  ICU 50

## ◆ operator==()

virtual U_I18N_API bool icu::TimeZoneFormat::operator== | ( | const Format & | other | ) | const
| overridevirtual

Return true if the given Format objects are semantically equal.

Objects of different subclasses are considered unequal.

Parameters

  other | The object to be compared with.

Returns
  Return true if the given Format objects are semantically equal. Objects of different subclasses are considered unequal.

Stable:
  ICU 50

Implements icu::Format.

## ◆ parse() [1/2]

virtual U_I18N_API TimeZone* icu::TimeZoneFormat::parse | ( | UTimeZoneFormatStyle | style,
|  | const UnicodeString & | text,
|  | ParsePosition & | pos,
|  | int32_t | parseOptions,
|  | UTimeZoneFormatTimeType * | timeType = `nullptr`
| ) |  | const
| virtual

Returns a `TimeZone` by parsing the time zone string according to the given parse position, the specified format style and parse options.

Parameters

  text | The text contains a time zone string at the position.
  style | The format style
  pos | The position.
  parseOptions | The parse options represented by bitwise flags of UTimeZoneFormatParseOption.
  timeType | The output argument for receiving the time type (standard/daylight/unknown), or nullptr if the information is not necessary.

Returns
  A `TimeZone`, or null if the input could not be parsed.

See also
  UTimeZoneFormatStyle
  UTimeZoneFormatParseOption
  UTimeZoneFormatTimeType

Stable:
  ICU 50

## ◆ parse() [2/2]

U_I18N_API TimeZone* icu::TimeZoneFormat::parse | ( | UTimeZoneFormatStyle | style,
|  | const UnicodeString & | text,
|  | ParsePosition & | pos,
|  | UTimeZoneFormatTimeType * | timeType = `nullptr`
| ) |  | const

Returns a `TimeZone` by parsing the time zone string according to the given parse position, the specified format style and the default parse options.

Parameters

  text | The text contains a time zone string at the position.
  style | The format style
  pos | The position.
  timeType | The output argument for receiving the time type (standard/daylight/unknown), or nullptr if the information is not necessary.

Returns
  A `TimeZone`, or null if the input could not be parsed.

See also
  UTimeZoneFormatStyle
  UTimeZoneFormatParseOption
  UTimeZoneFormatTimeType

Stable:
  ICU 50

## ◆ parseObject()

virtual U_I18N_API void icu::TimeZoneFormat::parseObject | ( | const UnicodeString & | source,
|  | Formattable & | result,
|  | ParsePosition & | parse_pos
| ) |  | const
| overridevirtual

Parse a string to produce an object.

This methods handles parsing of time zone display strings into Formattable objects with `TimeZone`.

Parameters

  source | The string to be parsed into an object.
  result | Formattable to be set to the parse result. If parse fails, return contents are undefined.
  parse_pos | The position to start parsing at. Upon return this param is set to the position after the last character successfully parsed. If the source is not parsed successfully, this param will remain unchanged.

Returns
  A newly created Formattable* object, or nullptr on failure. The caller owns this and should delete it when done.

Stable:
  ICU 50

Implements icu::Format.

## ◆ parseOffsetISO8601()

U_I18N_API int32_t icu::TimeZoneFormat::parseOffsetISO8601 | ( | const UnicodeString & | text,
|  | ParsePosition & | pos
| ) |  | const

Returns offset from GMT(UTC) in milliseconds for the given ISO 8601 style time zone string.

When the given string is not an ISO 8601 time zone string, this method sets the current position as the error index to `ParsePosition pos` and returns 0.

Parameters

  text | The text contains ISO8601 style time zone string (e.g. "-08:00", "Z") at the position.
  pos | The ParsePosition object.

Returns
  The offset from GMT(UTC) in milliseconds for the given ISO 8601 style time zone string.

See also
  formatOffsetISO8601Basic
  formatOffsetISO8601Extended

Stable:
  ICU 50

## ◆ parseOffsetLocalizedGMT()

U_I18N_API int32_t icu::TimeZoneFormat::parseOffsetLocalizedGMT | ( | const UnicodeString & | text,
|  | ParsePosition & | pos
| ) |  | const

Returns offset from GMT(UTC) in milliseconds for the given localized GMT offset format string.

When the given string cannot be parsed, this method sets the current position as the error index to `ParsePosition pos` and returns 0.

Parameters

  text | The text contains a localized GMT offset string at the position.
  pos | The ParsePosition object.

Returns
  The offset from GMT(UTC) in milliseconds for the given localized GMT offset format string.

See also
  formatOffsetLocalizedGMT

Stable:
  ICU 50

## ◆ parseOffsetShortLocalizedGMT()

U_I18N_API int32_t icu::TimeZoneFormat::parseOffsetShortLocalizedGMT | ( | const UnicodeString & | text,
|  | ParsePosition & | pos
| ) |  | const

Returns offset from GMT(UTC) in milliseconds for the given short localized GMT offset format string.

When the given string cannot be parsed, this method sets the current position as the error index to `ParsePosition pos` and returns 0.

Parameters

  text | The text contains a short localized GMT offset string at the position.
  pos | The ParsePosition object.

Returns
  The offset from GMT(UTC) in milliseconds for the given short localized GMT offset format string.

See also
  formatOffsetShortLocalizedGMT

Stable:
  ICU 51

## ◆ setDefaultParseOptions()

U_I18N_API void icu::TimeZoneFormat::setDefaultParseOptions | ( | uint32_t | flags | ) |

Sets the default parse options.

Note: By default, an instance of `TimeZoneFormat` created by createInstance has no parse options set (UTZFMT_PARSE_OPTION_NONE). To specify multiple options, use bitwise flags of UTimeZoneFormatParseOption.

See also
  UTimeZoneFormatParseOption

Stable:
  ICU 50

## ◆ setGMTOffsetDigits()

U_I18N_API void icu::TimeZoneFormat::setGMTOffsetDigits | ( | const UnicodeString & | digits,
|  | UErrorCode & | status
| ) |  |

Sets the decimal digit characters used for localized GMT format.

The input `digits` must contain exactly 10 code points (Unicode supplementary characters are also allowed) representing digit 0 to digit 9 in the ascending order. When the input `digits` does not satisfy the condition, `U_ILLEGAL_ARGUMENT_ERROR` will be set to the return status.

Parameters

  digits | The decimal digits used for localized GMT format.
  status | Receives the status.

See also
  getGMTOffsetDigits

Stable:
  ICU 50

## ◆ setGMTOffsetPattern()

U_I18N_API void icu::TimeZoneFormat::setGMTOffsetPattern | ( | UTimeZoneFormatGMTOffsetPatternType | type,
|  | const UnicodeString & | pattern,
|  | UErrorCode & | status
| ) |  |

Sets the offset pattern for the given offset type.

Parameters

  type | The offset pattern type enum.
  pattern | The offset pattern used for localized GMT format for the type.
  status | Receives the status.

See also
  getGMTOffsetPattern

Stable:
  ICU 50

## ◆ setGMTPattern()

U_I18N_API void icu::TimeZoneFormat::setGMTPattern | ( | const UnicodeString & | pattern,
|  | UErrorCode & | status
| ) |  |

Sets the localized GMT format pattern.

The pattern must contain a single argument {0}, for example "GMT {0}".

Parameters

  pattern | The localized GMT format pattern to be used by this object.
  status | Receives the status.

See also
  getGMTPattern

Stable:
  ICU 50

## ◆ setGMTZeroFormat()

U_I18N_API void icu::TimeZoneFormat::setGMTZeroFormat | ( | const UnicodeString & | gmtZeroFormat,
|  | UErrorCode & | status
| ) |  |

Sets the localized GMT format string for GMT(UTC) itself (GMT offset is 0).

Parameters

  gmtZeroFormat | The localized GMT format string for GMT(UTC).
  status | Receives the status.

See also
  getGMTZeroFormat

Stable:
  ICU 50

## ◆ setTimeZoneNames()

U_I18N_API void icu::TimeZoneFormat::setTimeZoneNames | ( | const TimeZoneNames & | tznames | ) |

Sets the time zone display name data to this format instance.

Parameters

  tznames | TimeZoneNames object to be set.

Stable:
  ICU 50

The documentation for this class was generated from the following file:

- i18n/unicode/tzfmt.h